CGAL 6.2 - Polynomial: PolynomialTraits_d::SquareFreeFactorize Concept Reference

CGAL 6.2 - Polynomial

Loading...
Searching...
No Matches
List of all members
PolynomialTraits_d::SquareFreeFactorize Concept Reference
Reference Manual » Concepts

## Definition

This `Functor` computes a square-free factorization of a `PolynomialTraits_d::Polynomial_d`.

A polynomial \( p\) is factored into square-free and pairwise coprime non-constant factors \( g_i\) with multiplicities \( m_i\) and a constant factor \( a\), such that \( p = a \cdot g_1^{m_1} \cdot ... \cdot g_n^{m_n}\).

The pairs \( (g_i,m_i)\) are written into the given output iterator.

This functor is well defined if `PolynomialTraits_d::Polynomial_d` is a `UniqueFactorizationDomain`.

Refines
  `Assignable`
  `CopyConstructible`
  `DefaultConstructible`

See also
  `Polynomial_d`
  `PolynomialTraits_d`
  `PolynomialTraits_d::SquareFreeFactorizeUpToConstantFactor`
  `PolynomialTraits_d::MakeSquareFree`
  `PolynomialTraits_d::IsSquareFree`

## Operations
template<class OutputIterator >
OutputIterator | operator() (PolynomialTraits_d::Polynomial_d p, OutputIterator it, PolynomialTraits_d::Innermost_coefficient_type &a)
| Computes the square-free factorization of \( p\) and returns the past-the-end iterator of the written range.
template<class OutputIterator >
OutputIterator | operator() (PolynomialTraits_d::Polynomial_d p, OutputIterator it)
| As the first operator, just not computing the factor \( a\).

## Member Function Documentation

## ◆ operator()()

template<class OutputIterator >

OutputIterator PolynomialTraits_d::SquareFreeFactorize::operator() | ( | PolynomialTraits_d::Polynomial_d | p,
|  | OutputIterator | it,
|  | PolynomialTraits_d::Innermost_coefficient_type & | a
| ) |  |

Computes the square-free factorization of \( p\) and returns the past-the-end iterator of the written range.

Precondition
  `std::iterator_traits< OutputIterator >::value_type` must be constructible from `std::pair<PolynomialTraits_d::Polynomial_d,int>`.